//		"Chunky"
//	> Blockscape Chunk System
//	> Zapk, BL_ID 12270

function Chunky()
{
	%obj = new ScriptGroup()
	{
		class = Chunky;
	};

	return %obj;
}

function Chunky::getChunk(%this, %id)
{
	%id = strreplace(%id, " ", "_");
	%id = strreplace(%id, "-", "_");
	if(%id $= "")
	{
		return -1;
	}
	
	%obj = "Chunky_Chunk_" @ %id;
	
	if(!isObject(%obj))
	{
		%chunk = new ScriptGroup(%obj);
		%this.add(%chunk);
		return %chunk;
	}
	else
	{
		return %obj;
	}
}

function Chunky::isChunk(%this, %id)
{
	%id = strreplace(%id, " ", "_");
	%id = strreplace(%id, "-", "_");
	if(%id $= "")
	{
		return false;
	}
	
	%obj = "Chunky_Chunk_" @ %id;
	if(isObject(%obj))
	{
		return true;
	}
	
	return false;
}

function Chunky::loadChunk(%this, %id)
{
	%file = %id;
	%id = strreplace(%id, " ", "_");
	%id = strreplace(%id, "-", "_");
	if(%file $= "")
	{
		return false;
	}
	
	%seed = $Blockscape::Perlin.seed;
	if(%seed $= "")
	{
		BS_createPerlin();
		%seed = $Blockscape::Perlin.seed;
		if(%seed $= "")
		{
			error("Chunky::loadChunk(int id): Unable to fetch perlin seed");
			return;
		}
	}
	
	%file = "base/server/blockscape/chunky/" @ %seed @ "/" @ %file @ ".chunk";
	if(!isFile(%file))
	{
		return false;
	}
	
	%fo = new fileObject();
	%fo.openForRead(%file);
		
	%this.__loadLoop(%fo, "", %id);
	
	return (%bricks);
}

function Chunky::__loadLoop(%this, %fo, %lastBrick, %queueNum)
{
	cancel(%this.loadLoopQueue[%queueNum]);
	if(%fo.isEOF() | !isObject(%fo))
	{
		%fo.close();
		%fo.delete();
		return true;
	}
	
	%line = %fo.readLine();
	if(%line $= "" | getFieldCount(%line) < 2)
	{
		%this.loadLoopQueue[%queueNum] = %this.schedule(1, __loadLoop, %fo, %lastBrick, %queueNum);
		return;
	}
	
	%firstField = getField(%line, 0);
	
	if(%firstField !$= "+-")
	{
		%args = "";
		for(%a = 0; %a < getFieldCount(%line); %a++)
		{
			%field = getField(%line, %a);
			if(%field $= "")
			{
				%this.loadLoopQueue[%queueNum] = %this.schedule(2, __loadLoop, %fo, %lastBrick, %queueNum);
				return;
			}
			
			%args = %args @ (%args $= "" ? "" : ",") @ "\"" @ %field @ "\"";
		}
		
		if(!$Blockscape::isBlock[%firstField])
		{
			//eval("%lastBrick = BS_plantBrick(" @ %args @ ");");
			//if(!%bricks) { %bricks = true; }
		}
	}
	else if(isObject(%lastBrick))
	{
		if((%field = getField(%line, 1)) $= "" | (%value = getFields(%line, 2, getFieldCount(%line))) $= "")
		{
			%this.loadLoopQueue[%queueNum] = %this.schedule(2, __loadLoop, %fo, %lastBrick, %queueNum);
			return;
		}
		else
		{
			eval(%lastBrick @ "." @ %field @ " = \"" @ %value @ "\";");
		}
	}
	
	%this.loadLoopQueue[%queueNum] = %this.schedule(2, __loadLoop, %fo, %lastBrick, %queueNum);
	return;
}

function Chunky::saveChunk(%this, %id)
{
	%file = %id;
	%id = strreplace(%id, " ", "_");
	%id = strreplace(%id, "-", "_");
	if(%file $= "")
	{
		return false;
	}
	
	%obj = "Chunky_Chunk_" @ %id;
	if(!isObject(%obj))
	{
		return false;
	}
	
	%seed = $Blockscape::Perlin.seed;
	if(%seed $= "")
	{
		BS_createPerlin();
		%seed = $Blockscape::Perlin.seed;
		if(%seed $= "")
		{
			error("Chunky::loadChunk(int id): Unable to fetch perlin seed");
			return false;
		}
	}
	
	%file = "base/server/blockscape/chunky/" @ %seed @ "/" @ %file @ ".chunk";
	if(isFile(%file))
	{
		fileDelete(%file);
	}
	
	if(!isObject(%obj))
	{
		return false;
	}
	
	%fo = new fileObject();
	%fo.openForWrite(%file);
		
	for(%a = 0; %a < %obj.getCount(); %a++)
	{
		%brick = %obj.getObject(%a);
		
		if(%brick.getClassName() !$= "fxDTSBrick" || %brick.creationCallMethod $= "")
		{
			continue;
		}
		
		%fo.writeLine(%brick.creationCallMethod);
		
		for(%b = 0; (%tagged = %brick.getTaggedField(%b)) !$= ""; %b++)
		{
			%fo.writeLine("+-" TAB %tagged);
		}
		
	}
	
	%fo.close();
	%fo.delete();
}

function Chunky::deleteChunk(%this, %rid)
{
	%id = strreplace(%rid, " ", "_");
	%id = strreplace(%id, "-", "_");
	if(%id $= "")
	{
		return false;
	}
	
	cancel(%this.loadLoopQueue[%id]);
	BS_queueOnDelete(%rid);
	
	%obj = "Chunky_Chunk_" @ %id;
	
	if(isObject(%obj))
	{
		%obj.delete();
		return true;
	}
	
	return false;
}

function Chunky::endChunkLife(%this, %id)
{
	%this.saveChunk(%id);
	%this.deleteChunk(%id);
}

function Chunky::extendChunkLife(%this, %id)
{
	cancel(%this.chunkEndLifeSchedule[%id]);
	%this.chunkEndLifeSchedule[%id] = %this.schedule(10000, endChunkLife, %id);
}