if(!isObject(BSAxeItem))
{
	datablock itemData(BSAxeItem)
	{
		category		= "Weapon";
		className		= "Weapon";
		
		shapeFile		= "Add-Ons/GameMode_BlockScape/res/shapes/axe.dts";
		mass			= 1;
		density 		= 0.2;
		elasticity		= 0.2;
		friction		= 0.6;
		emap			= true;
	
		uiName			= "Axe";
		iconName		= "Add-Ons/GameMode_BlockScape/res/shapes/axe";
	
		image			= BSAxeImage;
		canDrop			= true;
	};
	
	datablock shapeBaseImageData(BSAxeImage)
	{
		// SpaceCasts
		raycastWeaponRange = 6;
		raycastWeaponTargets = $TypeMasks::All;
		raycastDirectDamage = 0;
		raycastExplosionProjectile = swordProjectile;
		raycastExplosionSound = swordHitSound;
		
		shapeFile		= "Add-Ons/GameMode_BlockScape/res/shapes/axe.dts";
		emap			= true;
		mountPoint = 0;
		offset = "0 0 0";
		correctMuzzleVector = false;
		className		= "WeaponImage";
		
		item			= BSAxeItem;
		ammo			= " ";
		projectile		= swordProjectile;
		projectileType	= Projectile;
		
		melee			= true;
		doRetraction	= false;
		armReady		= true;
	
		stateName[0]					= "Activate";
		stateTimeoutValue[0]			= 0.1;
		stateTransitionOnTimeout[0]		= "Ready";
	
		stateName[1]					= "Ready";
		stateTransitionOnTriggerDown[1]	= "PreFire";
		stateAllowImageChange[1]		= true;
	
		stateName[2]					= "PreFire";
		stateScript[2]					= "onPreFire";
		stateAllowImageChange[2]		= false;
		stateTimeoutValue[2]			= 0.1;
		stateTransitionOnTimeout[2]		= "Fire";
	
		stateName[3]					= "Fire";
		stateTransitionOnTimeout[3]		= "CheckFire";
		stateTimeoutValue[3]			= 0.3;
		stateFire[3]					= true;
		stateAllowImageChange[3]		= false;
		stateSequence[3]				= "Fire";
		stateScript[3]					= "onFire";
		stateWaitForTimeout[3]			= true;
	
		stateName[4]					= "CheckFire";
		stateTransitionOnTriggerUp[4]	= "StopFire";
		stateTransitionOnTriggerDown[4]	= "Fire";
	
		stateName[5]					= "StopFire";
		stateTransitionOnTimeout[5]		= "Ready";
		stateTimeoutValue[5]			= 0.1;
		stateAllowImageChange[5]		= false;
		stateWaitForTimeout[5]			= true;
		stateSequence[5]				= "StopFire";
		stateScript[5]					= "onStopFire";
	};
}

function BSAxeImage::onPreFire(%this, %obj, %slot)
{
	%obj.playThread(2, "armAttack");
}

function BSAxeImage::onFire(%this, %obj, %slot)
{
	Parent::onFire(%this, %obj, %slot);
	ServerPlayPitched3D("itemSwing" @ getRandom(1, 3), %obj.getPosition());
}

function BSAxeImage::onStopFire(%this, %obj, %slot)
{
	%obj.playThread(2, "root");
}

function BSAxeImage::onHitObject(%this, %obj, %slot, %col, %pos, %normal)
{
	if(%col.getClassName() $= "fxDTSBrick")
	{
		%col.itemAttack(%obj, %obj.client, "axe");
	}
	
	parent::onHitObject(%this, %obj, %slot, %col, %pos, %normal);
}