function BSE()
{
	exec("Add-Ons/GameMode_Blockscape/server.cs");
	MessageAll('', "\c6Blockscape code manually reloaded.");
}

if(isFile("base/server/blockscape/data.cs") && !isObject(BSSimSet))
{
	exec("base/server/blockscape/data.cs");
	schedule(0,0,eval,"BSSimSet.saveTick();");
}

if(isFile("Add-Ons/System_Zapkraft/server.cs") && !isFunction("ZapkraftReload"))
{
	exec("Add-Ons/System_Zapkraft/server.cs");
}

if(!isObject(BSSimSet))
{
	new SimSet(BSSimSet);
	BSSimSet.saveTick();
}

function getPickLevelFromName(%name)
{
	for(%a = 0; $Blockscape::PickaxeLevel::Name[%a] !$= ""; %a++)
	{
		if($Blockscape::PickaxeLevel::Name[%a] $= %name)
		{
			return %a;
		}
	}
	return -1;
}

function BS_megaAnnounce(%msg)
{
	MessageAll('MsgError', "<font:Impact:40>\c6" @ %msg);
}

function ServerPlayPitched3D(%sound, %position)
{
	%pitch = 1.5 - (getRandom() / 2);
	
	for(%a = 0; %a < ClientGroup.getCount(); %a++)
	{
		%c = ClientGroup.getObject(%a);
		
		commandToClient(%c, 'TimeScale', %pitch);
		%c.play3D(%sound, %position);
		commandToClient(%c, 'TimeScale', 1.0);
	}
}

function BS_generateTerrain(%id)
{
	if($Blockscape::Chunky.loadChunk(%id))
	{
		return;
	}
	$Blockscape::Queue::Started[$Blockscape::Queue::CompleteNum] = true;
	%ax = mFloor(getWord(%id, 0) * 16);
	%ay = mFloor(getWord(%id, 1) * 16);
	$Blockscape::PlantNumber++;
	BS_terrainLoop(0, 0, %ax, %ay, $Blockscape::PlantNumber, "", %id);
}

function BS_terrainLoop(%x, %y, %ax, %ay, %plantnum, %array, %id)
{
	cancel($Blockscape::PlantSchedule[%plantnum]);
	
	if($Blockscape::deletingAll)
	{
		return;
	}
	
	%bx = (%ax + %x) * 2;
	%by = (%ay + %y) * 2;
	%bz = mFloor($Blockscape::Perlin.noise3D((%x + %ax + 0.01) / 100, (%y + %ay + 0.01) / 100, 0) * 50);
	%bz = mFloor(%bz / 2) * 2;
	%bpos = %bx SPC %by SPC %bz;
	%brick = BS_plantBrick(%bpos, "BrickBlockscapeData", -1, 1);
	
	%array = trim(%array SPC %brick);
	
	if(%x < 16 && %y < 16)
	{
		if(%x < 16)
		{
			%x++;
			if(%y < 16 && %x == 16)
			{
				%x = 0;
				if((%y + 1) < 16)
				{
					%y++;
				}
				else
				{
					BS_chunkFinish(%array, %id);
					return;
				}
			}
		}
		
		$Blockscape::PlantSchedule[%plantnum] = schedule(1, 0, BS_terrainLoop, %x, %y, %ax, %ay, %plantnum, %array, %id);
	}
}

function BS_chunkFinish(%array, %id)
{
	for(%a = 0; %a < getWordCount(%array); %a++)
	{
		%brick = getWord(%array, %a);
		if(!isObject(%brick))
		{
			continue;
		}
		%position = %brick.getPosition();
		
		if(!%s)
		{
			ServerPlay3D(chunkPlantSound, %position);
			%s = true;
		}
		
		if(!getRandom(0, 100))
		{
			%xpos = getWord(%position, 0);
			%ypos = getWord(%position, 1);
			%zpos = getWord(%position, 2);
			%position[0] = %xpos + 2 SPC %ypos;
			%position[1] = %xpos + 4 SPC %ypos;
			%position[2] = %xpos - 2 SPC %ypos;
			%position[3] = %xpos - 4 SPC %ypos;
			%position[4] = %xpos SPC %ypos + 2;
			%position[5] = %xpos SPC %ypos + 4;
			%position[6] = %xpos SPC %ypos - 2;
			%position[7] = %xpos SPC %ypos - 4;
			for(%a = 0; %a < 8; %a++)
			{
				if($Blockscape::isTree[%position[%a]] || $Blockscape::groundLevel[%position[%a]] > (%zpos + 1))
				{
					%continue = true;
				}
			}
			if(%continue)
			{
				continue;
			}
			
			%chunk = %brick.chunk;
			announce("\c4" @ %chunk.getID());
			%log[0] = BS_plantBrick(VectorAdd(%position, "0 0 2"), "BrickBlockscapeData", 60, false, -1, true, %chunk);
			%log[1] = BS_plantBrick(VectorAdd(%position, "0 0 4"), "BrickBlockscapeData", 60, false, -1, true, %chunk);
			%log[2] = BS_plantBrick(VectorAdd(%position, "0 0 6"), "BrickBlockscapeData", 60, false, -1, true, %chunk);
			%log[3] = BS_plantBrick(VectorAdd(%position, "0 0 8"), "BrickBlockscapeData", 60, false, -1, true, %chunk);
			%leaf[%lc = 0] = BS_plantBrick(VectorAdd(%position, "0 0 10"), "BrickBlockscapeData", 32, false, -1, true, %chunk);
			%leaf[%lc++] = BS_plantBrick(VectorAdd(%position, "0 2 10"), "BrickBlockscapeData", 32, false, -1, true, %chunk);
			%leaf[%lc++] = BS_plantBrick(VectorAdd(%position, "0 -2 10"), "BrickBlockscapeData", 32, false, -1, true, %chunk);
			%leaf[%lc++] = BS_plantBrick(VectorAdd(%position, "2 0 10"), "BrickBlockscapeData", 32, false, -1, true, %chunk);
			%leaf[%lc++] = BS_plantBrick(VectorAdd(%position, "-2 0 10"), "BrickBlockscapeData", 32, false, -1, true, %chunk);
			
			%leaf[%lc++] = BS_plantBrick(VectorAdd(%position, "0 2 8"), "BrickBlockscapeData", 32, false, -1, true, %chunk);
			%leaf[%lc++] = BS_plantBrick(VectorAdd(%position, "0 -2 8"), "BrickBlockscapeData", 32, false, -1, true, %chunk);
			%leaf[%lc++] = BS_plantBrick(VectorAdd(%position, "2 0 8"), "BrickBlockscapeData", 32, false, -1, true, %chunk);
			%leaf[%lc++] = BS_plantBrick(VectorAdd(%position, "-2 0 8"), "BrickBlockscapeData", 32, false, -1, true, %chunk);
			if(getRandom(0,8))
				%leaf[%lc++] = BS_plantBrick(VectorAdd(%position, "2 2 8"), "BrickBlockscapeData", 32, false, -1, true, %chunk);
			if(getRandom(0,8))
				%leaf[%lc++] = BS_plantBrick(VectorAdd(%position, "-2 2 8"), "BrickBlockscapeData", 32, false, -1, true, %chunk);
			if(getRandom(0,8))
				%leaf[%lc++] = BS_plantBrick(VectorAdd(%position, "-2 -2 8"), "BrickBlockscapeData", 32, false, -1, true, %chunk);
			if(getRandom(0,8))
				%leaf[%lc++] = BS_plantBrick(VectorAdd(%position, "2 -2 8"), "BrickBlockscapeData", 32, false, -1, true, %chunk);
			
			%leaf[%lc++] = BS_plantBrick(VectorAdd(%position, "0 2 6"), "BrickBlockscapeData", 32, false, -1, true, %chunk);
			%leaf[%lc++] = BS_plantBrick(VectorAdd(%position, "0 -2 6"), "BrickBlockscapeData", 32, false, -1, true, %chunk);
			%leaf[%lc++] = BS_plantBrick(VectorAdd(%position, "2 0 6"), "BrickBlockscapeData", 32, false, -1, true, %chunk);
			%leaf[%lc++] = BS_plantBrick(VectorAdd(%position, "-2 0 6"), "BrickBlockscapeData", 32, false, -1, true, %chunk);
			%leaf[%lc++] = BS_plantBrick(VectorAdd(%position, "2 2 6"), "BrickBlockscapeData", 32, false, -1, true, %chunk);
			%leaf[%lc++] = BS_plantBrick(VectorAdd(%position, "-2 2 6"), "BrickBlockscapeData", 32, false, -1, true, %chunk);
			%leaf[%lc++] = BS_plantBrick(VectorAdd(%position, "-2 -2 6"), "BrickBlockscapeData", 32, false, -1, true, %chunk);
			%leaf[%lc++] = BS_plantBrick(VectorAdd(%position, "2 -2 6"), "BrickBlockscapeData", 32, false, -1, true, %chunk);
			
			%lea = 0;
			%loa = 0;
			for(%i = 0; %i <= %lc; %i++)
			{
				%leaf[%i].isTreeLeaf = true;
				%leaf[%i].isTree = true;
				%lea = trim(%lea TAB %leaf[%i]);
			}
			for(%i = 0; %i <= 3; %i++)
			{
				%log[%i].isTreeLog = true;
				%log[%i].isTree = true;
				%loa = trim(%loa TAB %log[%i]);
			}
			
			for(%i = 0; %i <= 3; %i++)
			{	
				%log[%i].leafArray = %lea;
				%log[%i].logArray = %loa;
			}
				
				
			$Blockscape::isTree[%xpos SPC %ypos] = true;
		}
	}
	
	$Blockscape::Chunky.extendChunkLife(%id);
	BS_doQueueFinished();
}

if($Blockscape::Queue::CompleteNum $= "")
{
	$Blockscape::Queue::CompleteNum = 0;
}
if($Blockscape::Queue::AddedNum $= "")
{
	$Blockscape::Queue::AddedNum = 0;
}

function BS_doQueueFinished()
{
	$Blockscape::Queue::isInQueue[$Blockscape::Queue::CompleteNum] = false;
	$Blockscape::Queue::CompleteNum++;
	BS_doQueueCheck();
}

function BS_doQueueBuild(%id)
{
	if(!$Blockscape::Queue::isInQueue[%id])
	{
		$Blockscape::Queue::CID[$Blockscape::Queue::AddedNum] = %id;
		$Blockscape::Queue::AddedNum++;
		$Blockscape::Queue::isInQueue[%id] = true;
	}
	BS_doQueueCheck();
}

function BS_doQueueCheck()
{
	if(!$Blockscape::Queue::Started[$Blockscape::Queue::CompleteNum] && $Blockscape::Queue::CID[$Blockscape::Queue::CompleteNum] !$= "")
	{
		if($Blockscape::Queue::CID[$Blockscape::Queue::CompleteNum] $= "_SKIP")
		{
			$Blockscape::Queue::CompleteNum++;
			return BS_doQueueCheck();
		}
		BS_generateTerrain($Blockscape::Queue::CID[$Blockscape::Queue::CompleteNum]);
	}
}

function BS_queueOnDelete(%id)
{
	announce(%id);
	$Blockscape::Queue::isInQueue[%id] = false;
	for(%a = $Blockscape::Queue::CompleteNum; %a <= $Blockscape::Queue::AddedNum; %a++)
	{
		if($Blockscape::Queue::CID[%a] $= %id)
		{
			$Blockscape::Queue::CID[%a] = "_SKIP";
			announce(%a SPC $Blockscape::Queue::CID[%a]);
		}
	}
}

function serverCmdBlockscapeHandshake(%this)
{
	%this.hasClient = true;
	
	commandToClient(%this, 'BSC_HUD_Load');
}

if(isPackage(BlockscapePackage))
{
	deactivatePackage(BlockscapePackage);
}

package BlockscapePackage
{
	function gameConnection::autoAdminCheck(%this)
	{
		commandToClient(%this, 'BlockscapeHandshake');
		return Parent::autoAdminCheck(%this);
	}
	function gameConnection::spawnPlayer(%this)
	{
		if(PlayerDropPoints.getObject(0).getTransform() !$= "0 0 10000 1 0 0 0")
		{
			PlayerDropPoints.getObject(0).setTransform("0 0 10000 1 0 0 0");
		}
		%this.SimSetInit();
		
		Parent::spawnPlayer(%this);
		serverCmdBuyBrick(%this);
		
		%this.player.TerrainLoop();
		
		if(isObject(groundPlane))
		{
			groundPlane.delete();
		}
		
		%tools = "BSPickaxeItem BSAxeItem 0 0 0";
		for(%a = 0; %a < getWordCount(%tools); %a++)
		{
			if(isObject(nameToID(getWord(%tools, %a))))
			{
				%this.player.tool[%a] = nameToID(getWord(%tools, %a));
				messageClient(%this, 'MsgItemPickup', "", %a, nameToID(getWord(%tools, %a)), true);
			}
			else
			{
				%this.player.tool[%a] = 0;
				messageClient(%this, 'MsgItemPickup', "", %a, 0, true);
			}
		}
		
		%this.player.setDatablock(PlayerNoJet);
		
		if(!%this.hasClient)
		{
			%this.windowMessage();
		}
		else
		{
			%this.play2D(blockscapeSpawnSound);
		}
		
		if(%this.dat.tutorialStage $= "")
		{
			%this.dat.tutorialStage = 0;
		}
		
		if(%this.dat.tutorialStage < 1)
		{
			%this.windowMessage("Hey there!", "Welcome to Blockscape!\n\nTo start off, take out your Axe and go chop a tree!");
		}
	}
	function serverCmdPlantBrick(%this)
	{
		if(%this.dat.tutorialStage < 5)
		{
			%this.windowMessage("Slow down!", "Before you can build, you must do the rest of the tutorial.");
			return;
		}
		if(isObject(%this.player.tempBrick))
		{
			%pos = %this.player.tempBrick.getPosition();
		}
		else
		{
			return;
		}
		%pos = (mFloatLength(getWord(%pos, 0) / 2, 0) * 2) SPC (mFloatLength(getWord(%pos, 1) / 2, 0) * 2) SPC (mFloatLength(getWord(%pos, 2) / 2, 0) * 2);
		if(isObject($Blockscape::brickFromPos[%pos]))
		{
			messageClient(%this, 'MsgPlantError_Overlap');
			return;
		}
		if(%this.dat.valueWood < 1)
		{
			centerPrint(%this, "<font:Impact:28>\c6No Wood!", 3);
			return;
		}
		%xpos = getWord(%pos, 0);
		%ypos = getWord(%pos, 1);
		%zpos = getWord(%pos, 2);
	
		//left and right blocks
		%position[0] = %xpos + 2 SPC %ypos SPC %zpos;
		%position[1] = %xpos - 2 SPC %ypos SPC %zpos;
		//front and behind blocks
		%position[2] = %xpos SPC %ypos + 2 SPC %zpos;
		%position[3] = %xpos SPC %ypos - 2 SPC %zpos;
		//above and below blocks
		%position[4] = %xpos SPC %ypos SPC %zpos + 2;
		%position[5] = %xpos SPC %ypos SPC %zpos - 2;
	
		for(%a = 0; %a < 6; %a++)
		{
			if(!isObject($Blockscape::brickFromPos[%position[%a]]))
			{
				%floatCount++;
			}
			else
			{
				%br = $Blockscape::brickFromPos[%position[%a]];
				%placedby = findClientByBL_ID(%br.placedByID);
				if(%br.placedByID > 0 && (!isObject(%placedby) | !getTrustLevel(%this, findClientByBL_ID(%br.placedByID))))
				{
					%cp = "<font:Impact:28>\c6Insufficient trust!";
					%cp = %cp @ "<br>\c6Built by \c4" @ getNameFromID(%br.placedByID) @ " \c6(\c4" @ %br.placedByID @ "\c6)";
					centerPrint(%this, %cp, 3);
					%this.play2D(ErrorSound);
					return;
				}
			}
		}
		if(%floatCount > 5)
		{
			messageClient(%this, 'MsgPlantError_Float');
			return;
		}
		%brick = BS_plantBrick(%pos, "BrickBlockscapeData", 59, 0, %this.bl_id);
		if(isObject(%brick))
		{
			%this.player.tempBrick.setTransform(%brick.getTransform());
			%this.dat.valueWood = Math_Subtract(%this.dat.valueWood, 1);
			ServerPlayPitched3D(BrickPlantSound, %brick.getPosition());
		}
		
		%this.refreshBlockscapeHUD();
		
		if(%this.dat.tutorialStage < 6)
		{
			%this.windowMessage("Amazing!", "Let's see what you've got! Plant at least 3 more wooden blocks.");
			%this.dat.tutorialStage = 6;
		}
		if(%this.dat.tutorialStage == 6)
		{
			if(%this.dat.tutorialBuildingCount++ >= 4)
			{
				%this.windowMessage("Fancy.", "You can also destroy your build with an axe. Try it!");
				%this.dat.tutorialStage = 7;
			}
		}
	}
	function serverCmdBuyBrick(%this)
	{
		%id = BrickBlockscapeData.getID();
		for(%i = 0; %i < 10; %i++)
		{
			Parent::serverCmdBuyBrick(%this,%i,%id);
			messageClient(%this,'MsgSetInvData',"",%i,%id);
		}
	}
	function ServerCmdDropTool(%this)
	{
		return;
	}
	function Armor::onTrigger(%this,%player,%slot,%val,%a,%b,%c)
	{
		%client = %player.client;
		Parent::onTrigger(%this,%player,%slot,%val,%a,%b,%c);
		if(%slot == 4 && %val && (%client.isVIP | %client.isAdmin))
		{
			%ray = containerRayCast(%player.getEyePoint(),vectorAdd(%player.getEyePoint(),vectorScale(%player.getEyeVector(),5 * getWord(%player.getScale(),2))),$TypeMasks::FxBrickObjectType,%player);
			%target = firstWord(%ray);
			if(isObject(%target))
			{
				%player.playThread(3,"activate2");
				%player.addVelocity("0 0 3.1");
			}
		}
	}
	function paintProjectile::onCollision(%this, %obj, %col, %fade, %pos, %normal)
	{
		if(%col.getClassName() !$= "fxDTSBrick")
		{
			return;
		}
		if(!isObject(%client = %obj.client))
		{
			return;
		}
		if(%col.placedByID < 0 | %col.placedByID $= "")
		{
			%cp = "<font:Impact:28>\c6Cannot paint world!";
			centerPrint(%client, %cp, 3);
			return;
		}
		%placedby = findClientByBL_ID(%col.placedByID);
		if(!isObject(%placedby) | !getTrustLevel(%client, findClientByBL_ID(%col.placedByID)))
		{
			%cp = "<font:Impact:28>\c6Insufficient trust!";
			%cp = %cp @ "<br>\c6Built by \c4" @ getNameFromID(%col.placedByID) @ " \c6(\c4" @ %col.placedByID @ "\c6)";
			centerPrint(%client, %cp, 3);
			return;
		}
		%col.setColor(%this.colorID);
	}
	function serverCmdWand(%this)
	{
		%cp = "<font:Impact:28>\c6No.";
		centerPrint(%this, %cp, 3);
		%this.play2D(ErrorSound);
		return;
	}
	function serverCmdUseHammer(%this)
	{
		%cp = "<font:Impact:28>\c6No.";
		centerPrint(%this, %cp, 3);
		%this.play2D(ErrorSound);
		return;
	}
};

activatePackage(BlockscapePackage);

function gameConnection::SimSetInit(%this)
{
	for(%a = 0; %a < BSSimSet.getCount(); %a++)
	{
		%sub = BSSimSet.getObject(%a);
		if(%sub.cid == %this.bl_id)
		{
			%sub.cname = %this.name;
			%this.dat = %sub;
			return;
		}
	}
	%dat = new ScriptObject()
	{
		cid = %this.bl_id;
		cname = %this.name;
	};
	%this.dat = %dat;
	BSSimSet.add(%this.dat);
}

function getNameFromID(%this)
{
	%ss = BSSimSet;
	for(%a = 0; %a < %ss.getCount(); %a++)
	{
		%sub = %ss.getObject(%a);
		if(%sub.cid == %this)
		{
			return %sub.cname;
		}
	}
}

function SimSet::saveTick(%this)
{
	cancel(%this.saveTick);
	
	%this.save("base/server/blockscape/data.cs");
	MessageAll('', "\c6Saved all data.");
	
	%this.saveTick = %this.schedule(60000, saveTick);
}

function fxDTSBrick::itemAttack(%this, %player, %client, %type)
{
	if(%this.stackBL_ID == 888888)
	{
		if(%client.windowOpen) { return; }
		if(%client.dat.tutorialStage < 2 && !%this.isTree)
		{
			%client.windowMessage("Oops!", "That isn't a tree! To continue in the game, you must chop a tree.");
			return;
		}
		if(%client.dat.tutorialStage < 2 && %type !$= "axe")
		{
			%client.windowMessage("Silly goose!", "It's about a billion times more effective to chop a tree with an Axe. Please do so!");
			return;
		}
		if(%client.dat.tutorialStage >= 2)
		{
			if(%client.dat.tutorialStage < 4 && %this.blockType !$= "Cobblestone")
			{
				%client.windowMessage("Nope!", "That isn't Cobblestone!\n\nGo and mine some Cobblestone. You can see its colour in your HUD.");
				return;
			}
		}
		if(%client.dat.tutorialStage == 7 && (%this.isTree | %this.blockType !$= "Wood"))
		{
			%client.windowMessage("Nope!", "You can destroy things you've built with an axe. Try it!");
			return;
		}
		if(%client.dat.tutorialStage == 4)
		{
			%client.windowMessage("Hold up...", "Before you can proceed, you must upgrade your pickaxe! Type /pick!");
			return;
		}
		if(%client.dat.tutorialStage == 5 || %client.dat.tutorialStage == 6)
		{
			%client.windowMessage("Hold up...", "Before you can proceed, you must build something! Try building like you normally would in Blockland.");
			return;
		}
		%pos = %this.getPosition();
		%xy = getWords(%pos, 0, 1);
		if($Blockscape::groundLevel[%xy] $= "")
		{
			%cp = "<font:Impact:28>\c6No terrain above!";
			centerPrint(%client, %cp, 3);
			%client.play2D(ErrorSound);
			return;
		}
		
		%dbn = %this.getDatablock().getName();
		if(%this.blockType $= "Wood")
		{
			if(%this.placedByID > 0)
			{
				%placedby = findClientByBL_ID(%this.placedByID);
				if(!isObject(%placedby) | !getTrustLevel(%client, findClientByBL_ID(%this.placedByID)))
				{
					%cp = "<font:Impact:28>\c6Insufficient trust!";
					%cp = %cp @ "<br>\c6Built by \c4" @ getNameFromID(%this.placedByID) @ " \c6(\c4" @ %this.placedByID @ "\c6)";
					centerPrint(%client, %cp, 3);
					%client.play2D(ErrorSound);
					return;
				}
			}
			for(%a = 0; %a < getFieldCount(%this.leafArray); %a++)
			{
				%leaf = getField(%this.leafArray, %a);
				
				if(%leaf != %this && isObject(%leaf))
				{
					%isLeaves = true;
					break;
				}
			}
			if(%isLeaves | %this.isTreeLeaf)
			{
				ServerPlayPitched3D(leavesHitSound, %pos);
			}
			ServerPlayPitched3D(BrickMoveSound, %pos);
			if(%client.dat.axeTier $= "")
			{
				%client.dat.axeTier = 0;
			}
			%dam = %this.blockDamage = Math_Add(%this.blockDamage, (%type $= "axe" ? $Blockscape::PickaxeLevel::Damage[%client.dat.axeTier] : 0.1));
			%hp = (%this.isTreeLog ? (%this.maxDamage * 1.5) : %this.maxDamage);
			centerPrint(%client, getUnderscores(%dam, %hp, (%this.isTree ? (%this.isTreeLog ? "Tree Trunk" : "Leaves") : %this.blockType)), 3);
			
			if(%this.blockDamage >= %hp)
			{
				if(%this.isTreeLog)
				{
					for(%a = 0; %a < getFieldCount(%this.logArray); %a++)
					{
						%log = getField(%this.logArray, %a);
						
						if(%log != %this && isObject(%log))
						{
							%otherLogs = true;
						}
					}
					if(!%otherLogs)
					{
						for(%a = 0; %a < getFieldCount(%this.leafArray); %a++)
						{
							%leaf = getField(%this.leafArray, %a);
							
							if(!isObject(%leaf))
							{
								continue;
							}
							
							//%leaf.fakeKillBrick("0 0 0", 200);
							%leaf.schedule(getRandom(1000, 10000), delete);
						}
						ServerPlay3D(treeTimberSound, %pos);
						if(%client.dat.tutorialStage < 2)
						{
							%client.windowMessage("Good work!", "You've chopped your first tree!\n\nNow, go and mine some Cobblestone. You can see its colour in your HUD.");
							%client.dat.tutorialStage = 2;
						}
					}
					else
					{
						if(%client.dat.tutorialStage < 1)
						{
							%client.windowMessage("Getting there!", "You've chopped a tree. However, let's finish it off!\n\nChop all the log until the tree timbers.");
							%client.dat.tutorialStage = 1;
						}
					}
				}
				
				%this.fakeKillBrick("0 0 0", 200);
				%this.schedule(200, delete);
				ServerPlayPitched3D(BrickBreakSound, %pos);
				%am = (%this.isTreeLog ? getRandom(2, 6) : 1);
				%cp = "<just:left><font:Impact:28>\c6+ \c4" @ %am SPC %this.blockType;
				centerPrint(%client, %cp, 3);
				%client.dat.value[getValueHash(%this.blockType)] = Math_Add(%client.dat.value[getValueHash(%this.blockType)], %am);
				
				%client.refreshBlockscapeHUD();
				
				if(%client.dat.tutorialStage == 7 && !%this.isTree)
				{
					%client.windowMessage("Way to go!", "It looks to me like you're ready to play now.\n\nHave fun!");
					%client.dat.tutorialStage = 8;
				}
			}
		}
		else if(%this.blockType !$= "")
		{
			ServerPlayPitched3D(BrickMoveSound, %pos);
			if(%client.dat.pickTier $= "")
			{
				%client.dat.pickTier = 0;
			}
			if(%client.dat.pickTier < $Blockscape::PickaxeLevel::RequiredTier[getPickLevelFromName(%this.blockType)])
			{
				centerPrint(%client, "<font:Impact:28>\c6Ore too hard!", 3);
				%client.play2D(ErrorSound);
				return;
			}
			%dam = %this.blockDamage = Math_Add(%this.blockDamage, (%type $= "pickaxe" ? $Blockscape::PickaxeLevel::Damage[%client.dat.pickTier] : 0.1));
			%hp = %this.maxDamage;
			if(%hp < 0)
			{
				centerPrint(%client, "<font:Impact:28>\c6Ore unbreakable!", 3);
				%client.play2D(ErrorSound);
				return;
			}
			centerPrint(%client, getUnderscores(%dam, %hp, %this.blockType), 3);
			
			if(%this.blockDamage >= %hp)
			{
				%this.fakeKillBrick("0 0 0", 200);
				BS_blockCheck(%pos);
				%this.schedule(200, delete);
				ServerPlayPitched3D(BrickBreakSound, %pos);
				%am = 1;
				%cp = "<just:left><font:Impact:28>\c6+ \c4" @ %am SPC %this.blockType;
				centerPrint(%client, %cp, 3);
				%client.dat.value[getValueHash(%this.blockType)] = Math_Add(%client.dat.value[getValueHash(%this.blockType)], %am);
				
				%client.refreshBlockscapeHUD();
				
				if(%client.dat.tutorialStage < 3 && %this.blockType $= "Cobblestone")
				{
					%client.windowMessage("Way to go!", "I think you're getting the hang of resources!\n\nObtain 6 Cobblestone so you can craft a Cobblestone Pickaxe!");
					%client.dat.tutorialStage = 3;
					return;
				}
				if(%client.dat.tutorialStage < 4 && %client.dat.valueCobblestone >= 6)
				{
					%client.windowMessage("You've got it!", "Now that you have 6 Cobblestone, type /pick to upgrade your pickaxe.");
					%client.dat.tutorialStage = 4;
					return;
				}
			}
		}
		return false;
	}
}

function getUnderscores(%dam, %max, %name)
{
	%dam = mFloatLength(%dam / %max * 15, 0);
	if(%dam > %max)
	{
		%dam = %max;
	}
	%string = %string @ "<font:Impact:65>\c6";
	for(%a = 1; %a <= (15-%dam); %a++)
	{
		%string = %string @ "_";
	}
	if(%name !$= "")
	{
		%string = %string @ "<br><font:impact:30>\c6" @ %name;
	}
	return %string;
}

function getValueHash(%this)
{
	%this = strreplace(%this, " ", "_");
	return %this;
}

function BS_blockCheck(%position)
{
	if($Blockscape::deletingAll)
	{
		return;
	}
	if(getBrickCount() > 260000)
	{
		MessageAll('MsgError', "\c6Maximum Blockland brick count achieved!");
		BS_clear();
	}
	%xpos = getWord(%position, 0);
	%ypos = getWord(%position, 1);
	%zpos = getWord(%position, 2);

	//left and right blocks
	%position[0] = %xpos + 2 SPC %ypos SPC %zpos;
	%position[1] = %xpos - 2 SPC %ypos SPC %zpos;
	//front and behind blocks
	%position[2] = %xpos SPC %ypos + 2 SPC %zpos;
	%position[3] = %xpos SPC %ypos - 2 SPC %zpos;
	//above and below blocks
	%position[4] = %xpos SPC %ypos SPC %zpos + 2;
	%position[5] = %xpos SPC %ypos SPC %zpos - 2;

	for(%a = 0; %a < 6; %a++)
	{
		if(!$Blockscape::isBlock[%position[%a]])
		{
			BS_plantBrick(%position[%a], "BrickBlockscapeData", -1);
		}
	}
}

function Player::getTerrainChunk(%this)
{
	%pos = %this.getPosition();
	return mFloor(getWord(%pos, 0) / 32) SPC mFloor(getWord(%pos, 1) / 32);
}

function Player::TerrainLoop(%this)
{
	cancel(%this.TerrainLoop);
	
	%xy = %this.getTerrainChunk();
	BS_chunkRadiusCheck(%xy, 4);
	
	if(isObject(%this.client))
	{
		%this.client.refreshBlockscapeHUD();
	}
	
	%this.TerrainLoop = %this.schedule(2000, TerrainLoop);
}

function gameConnection::refreshBlockscapeHUD(%this)
{
	if(%this.dat.pickTier $= "")
	{
		%this.dat.pickTier = 0;
	}
	
	if(%this.dat.axeTier $= "")
	{
		%this.dat.axeTier = 0;
	}
	
	commandToClient(%this, 'BSC_setHudData', "Tool", "Name1", $Blockscape::PickaxeLevel::Name[%this.dat.pickTier] SPC "Pickaxe", "setValue");
	commandToClient(%this, 'BSC_setHudData', "Tool", "Name2", $Blockscape::PickaxeLevel::Name[%this.dat.axeTier] SPC "Axe", "setValue");
	
	commandToClient(%this, 'BSC_setHudData', "Block", "Name1", (%this.dat.valueWood ? %this.dat.valueWood : 0) SPC "Wood", "setValue");
	
	if($Blockscape::PickaxeLevel::Name[%this.dat.pickTier + 1] $= "")
	{
		commandToClient(%this, 'BSC_setHudData', "Block", "Control2", false, "setVisible");
	}
	else
	{
		%nextTier = %this.dat.pickTier + 1;
		
		if(%this.dat.value[getValueHash($Blockscape::PickaxeLevel::Name[%nextTier])] $= "")
		{
			%this.dat.value[getValueHash($Blockscape::PickaxeLevel::Name[%nextTier])] = 0;
		}
		commandToClient(%this, 'BSC_setHudData', "Block", "Control2", true, "setVisible");
		commandToClient(%this, 'BSC_setHudData', "Block", "Name2", %this.dat.value[getValueHash($Blockscape::PickaxeLevel::Name[%nextTier])] SPC $Blockscape::PickaxeLevel::Name[%nextTier], "setValue");
		commandToClient(%this, 'BSC_setHudData', "Block", "Bitmap2", getColorIDTable($Blockscape::BlockColor[$Blockscape::PickaxeLevel::Name[%nextTier]]), "setColor");
	}
}

function gameConnection::windowMessage(%this, %header, %body, %callback)
{
	if(%this.hasClient)
	{
		%this.latestMessageCallback = %callback;
		%this.windowOpen = true;
		commandToClient(%this, 'BSC_MessageBox', %header, %body);
	}
	else
	{
		%this.play2D(ErrorSound);
		%link = "repository.zapkraft.net";
		commandToClient(%this, 'messageBoxOK', "You don't seem to have the client!", "Without the client, playing this game is nearly impossible.\n\n<a:" @ %link @ ">Client_Blockscape.zip</a>");
	}
}

function serverCmdBSC_OK(%this)
{
	%this.latestMessageCallback = "";
	%this.windowOpen = false;
}

function serverCmdHelp(%this)
{
	messageClient(%this, '', "\c6- \c4Blockscape Commands \c6-");
	
	messageClient(%this, '', "\c4/help \c6- Show a list of commands.");
	messageClient(%this, '', "\c4/pick \c6- Upgrade your pick to the next tier.");
	messageClient(%this, '', "\c4/axe \c6- Upgrade your axe to the next tier.");
	messageClient(%this, '', "\c4/inventory \c6- List all your materials.");
	messageClient(%this, '', "\c4/depth \c6- Display how deep in the ground you are.");
	messageClient(%this, '', "\c4/reset \c6- Delete your account and restart.");
}

function serverCmdPick(%this)
{
	if(%this.dat.tutorialStage < 4)
	{
		%this.windowMessage("Slow down!", "Please follow the tutorial before you break something.");
		return;
	}
	
	if(!isObject(%this.player))
	{
		return messageClient(%this, '', "\c6You do not have a player!");
	}
	if($Blockscape::PickaxeLevel::Name[%this.dat.pickTier + 1] $= "")
	{
		return messageClient(%this, '', "\c6There is no upgrade available!");
	}
	if(%this.dat.value[getValueHash($Blockscape::PickaxeLevel::Name[%this.dat.pickTier + 1])] < 6)
	{
		messageClient(%this, '', "\c6You do not have enough resources!");
		return messageClient(%this, '', "\c6You must gather more \c4" @ $Blockscape::PickaxeLevel::Name[%this.dat.pickTier + 1] @ "\c6.");
	}
	%this.dat.value[getValueHash($Blockscape::PickaxeLevel::Name[%this.dat.pickTier + 1])] = Math_Subtract(%this.dat.value[getValueHash($Blockscape::PickaxeLevel::Name[%this.dat.pickTier + 1])], 6);
	%this.dat.pickTier++;
	messageClient(%this, '', "\c6You have upgraded your pickaxe to \c4" @ $Blockscape::PickaxeLevel::Name[%this.dat.pickTier] @ "\c6.");
	%this.play2D(blockscapeUpgradeSound);
	
	%this.refreshBlockscapeHUD();
	
	if(%this.dat.tutorialStage < 5)
	{
		%this.windowMessage("Shiny!", "Now that you're a bit more familiar with resources, let's build something! Try building like you normally would in Blockland.");
		%this.dat.tutorialStage = 5;
	}
}

function serverCmdBSC_RequestInventory(%this)
{
	commandToClient(%this, 'BSC_addInventoryItem', "tool", "Pickaxe", $Blockscape::PickaxeLevel::Name[%this.dat.pickTier], "pickaxe");
	commandToClient(%this, 'BSC_addInventoryItem', "tool", "Axe", $Blockscape::PickaxeLevel::Name[%this.dat.axeTier], "axe");
	
	%arr = $Blockscape::MaterialArray;
	for(%a = 0; %a < getFieldCount(%arr); %a++)
	{
		%field = getField(%arr, %a);
		%val = %this.dat.value[getValueHash(%field)];
		if(%val > 0)
		{
			commandToClient(%this, 'BSC_addInventoryItem', "block", %field, %val, getColorIDTable($Blockscape::BlockColor[%field]));
		}
	}
}

function serverCmdBSC_RequestUpgrades(%this)
{
	%nextpick = $Blockscape::PickaxeLevel::Name[%this.dat.pickTier + 1];
	%nextaxe = $Blockscape::PickaxeLevel::Name[%this.dat.axeTier + 1];
	
	if(%nextpick $= "" && %nextaxe $= "")
	{
		commandToClient(%this, 'BSC_addUpgradeable', "_NONE");
		return;
	}
	if(%nextpick !$= "")
	{
		commandToClient(%this, 'BSC_addUpgradeable', "Pickaxe", %nextpick, "pickaxe");
	}
	if(%nextaxe !$= "")
	{
		commandToClient(%this, 'BSC_addUpgradeable', "Axe", %nextaxe, "axe");
	}
}

function serverCmdBSC_doUpgrade(%this, %tool)
{
	if(%this.dat.tutorialStage < 4)
	{
		%this.windowMessage("Slow down!", "Please follow the tutorial before you break something.");
		return;
	}
	if(%this.dat.tutorialStage < 5)
	{
		%this.windowMessage("Oops!", "Before you can do that, you must obtain a Cobblestone Pickaxe.\n\nFollow the tutorial!");
		return;
	}
	if(!isObject(%this.player))
	{
		%this.windowMessage("Upgrade Error", "You do not have a player!");
		return;
	}
	
	switch$(strlwr(%tool))
	{
		case "axe":
			if($Blockscape::PickaxeLevel::Name[%this.dat.axeTier + 1] $= "")
				return %this.windowMessage("Upgrade Error", "There is no upgrade available!");
			if(%this.dat.value[getValueHash($Blockscape::PickaxeLevel::Name[%this.dat.axeTier + 1])] < 6)
				return %this.windowMessage("Upgrade Error", "You do not have enough resources!\nYou must gather more " @ $Blockscape::PickaxeLevel::Name[%this.dat.axeTier + 1] @ ".");
			%this.dat.value[getValueHash($Blockscape::PickaxeLevel::Name[%this.dat.axeTier + 1])] = Math_Subtract(%this.dat.value[getValueHash($Blockscape::PickaxeLevel::Name[%this.dat.axeTier + 1])], 6);
			%this.dat.axeTier++;
			%this.windowMessage("Success!", "You have upgraded your axe to " @ $Blockscape::PickaxeLevel::Name[%this.dat.axeTier] @ ".");
			%this.play2D(blockscapeUpgradeSound);
			%this.refreshBlockscapeHUD();
			
		case "pickaxe":
			if($Blockscape::PickaxeLevel::Name[%this.dat.pickTier + 1] $= "")
				return %this.windowMessage("Upgrade Error", "There is no upgrade available!");
			if(%this.dat.value[getValueHash($Blockscape::PickaxeLevel::Name[%this.dat.pickTier + 1])] < 6)
				return %this.windowMessage("Upgrade Error", "You do not have enough resources!\nYou must gather more " @ $Blockscape::PickaxeLevel::Name[%this.dat.pickTier + 1] @ ".");
			%this.dat.value[getValueHash($Blockscape::PickaxeLevel::Name[%this.dat.pickTier + 1])] = Math_Subtract(%this.dat.value[getValueHash($Blockscape::PickaxeLevel::Name[%this.dat.pickTier + 1])], 6);
			%this.dat.pickTier++;
			%this.windowMessage("Success!", "You have upgraded your pickaxe to " @ $Blockscape::PickaxeLevel::Name[%this.dat.pickTier] @ ".");
			%this.play2D(blockscapeUpgradeSound);
			%this.refreshBlockscapeHUD();
			if(%this.dat.tutorialStage < 5)
			{
				%this.windowMessage("Shiny!", "Now that you're a bit more familiar with resources, let's build something! Try building like you normally would in Blockland.");
				%this.dat.tutorialStage = 5;
			}
			
		default:
			%this.windowMessage("Upgrade Error", "The tool you requested could not be found. This shouldn't be happening.");
	}
}

function serverCmdInventory(%this)
{
	if(!isObject(%this.player))
	{
		return messageClient(%this, '', "\c6You do not have a player!");
	}
	messageClient(%this, '', "\c6- \c4Your Materials \c6-");
	%arr = $Blockscape::MaterialArray;
	for(%a = 0; %a < getFieldCount(%arr); %a++)
	{
		%field = getField(%arr, %a);
		%val = %this.dat.value[getValueHash(%field)];
		if(%val > 0)
		{
			messageClient(%this, '', "\c6" @ %field @ " (" @ %val @ ")");
		}
	}
	
	%this.refreshBlockscapeHUD();
}

function serverCmdDepth(%this)
{
	if(!isObject(%this.player))
	{
		return messageClient(%this, '', "\c6You do not have a player!");
	}
	%pos = %this.player.getPosition();
	%x = mFloor(getWord(%pos, 0) / 2) * 2;
	%y = mFloor(getWord(%pos, 1) / 2) * 2;
	%z = mFloor(getWord(%pos, 2) / 2) * 2;
	%xy = %x SPC %y;
	if($Blockscape::groundLevel[%xy] $= "")
	{
		return messageClient(%this, '', "\c6No terrain above!");
	}
	%depth = ($Blockscape::groundLevel[%xy] - %z) / 2;
	messageClient(%this, '', "\c6" @ %depth);
}

function serverCmdReset(%this)
{
	%this.dat.delete();
	MessageAll('', "\c4" @ %this.name @ " \c6has reset their information.");
	%this.player.instantRespawn();
	
	%this.refreshBlockscapeHUD();
}

function BS_chunkCheck(%xy)
{
	if(!$Blockscape::Chunky.isChunk(%xy))
	{
		BS_plantChunk(%xy);
	}
	else
	{
		$Blockscape::Chunky.extendChunkLife(%xy);
	}
}

//x + + + + + x
//+ x + + + x -
//+ + x + x - -
//+ + + O - - -
//+ + x - x - -
//+ x - - - x -
//x - - - - - x

function BS_chunkRadiusCheck(%xy, %radius)
{
	BS_chunkCheck(%xy);

	for( %a = 1; %a <= %radius; %a++ )
	{
		%na = ( "-" @ %a );

		for( %b = %na + 1; %b < %a; %b++ )
		{
			BS_chunkCheck( BS_chunkAdd( %xy, %na SPC %b ) );
			BS_chunkCheck( BS_chunkAdd( %xy, %b SPC %na ) );
		}

		for( %b = %a - 1; %b > %na; %b-- )
		{
			BS_chunkCheck( BS_chunkAdd( %xy, %a SPC %b ) );
			BS_chunkCheck( BS_chunkAdd( %xy, %b SPC %a ) );
		}

		BS_chunkCheck( BS_chunkAdd( %xy, %na SPC %na ) );
		BS_chunkCheck( BS_chunkAdd( %xy, %na SPC %a ) );
		BS_chunkCheck( BS_chunkAdd( %xy, %a SPC %a ) );
		BS_chunkCheck( BS_chunkAdd( %xy, %a SPC %na ) );
	}
}

function BS_plantChunk(%id)
{
	if(getBrickCount() > 150000)
	{
		return;
	}
	if($Blockscape::Chunky.loadChunk(%id))
	{
		return;
	}
	else
	{
		BS_doQueueBuild(%id);
	}
}

function BS_chunkAdd(%xy1, %xy2)
{
	return getWords(VectorAdd(%xy1, %xy2), 0, 1);
}

function BS_clear()
{
	BS_clearingTick();
	$Blockscape::deletingAll = true;
	messageAll('MsgClearBricks', "\c6Wiping terrain.");
	$Blockscape::Chunky.chainDeleteCallback = "BS_clearFinish();";
	$Blockscape::Chunky.chainDeleteAll();
}

function BS_clearingTick()
{
	cancel($Blockscape::clearingTick);
	
	messageAll('', "\c6Clearing current terrain, please wait...");
	
	$Blockscape::clearingTick = schedule(3000, 0, BS_clearingTick);
}

function BS_clearFinish()
{
	BS_createPerlin();
	cancel($Blockscape::clearingTick);
	$Blockscape::deletingAll = false;
	deleteVariables("$Blockscape::isBlock*");
	deleteVariables("$Blockscape::groundLevel*");
	deleteVariables("$Blockscape::brickFromPos*");
	
	deleteVariables("$Blockscape::Queue::*");
	messageAll('MsgProcessComplete', "\c6Wipe process done.");
	for(%a = 0; %a < ClientGroup.getCount(); %a++)
	{
		%client = ClientGroup.getObject(%a);
		if(isObject(%client.player))
		{
			%client.player.kill();
		}
	}
}

function BS_createPerlin()
{
	if(isObject($Blockscape::Perlin))
	{
		$Blockscape::Perlin.delete();
	}
	$Blockscape::Perlin = PerlinNoise(getRandom(999999));
}

function BS_createChunky()
{
	if(isObject($Blockscape::Chunky))
	{
		$Blockscape::Chunky.delete();
	}
	$Blockscape::Chunky = Chunky();
}

function BS_plantBrick(%pos, %db, %col, %isgen, %bl_id, %iswood, %forcechunk)
{
	if(%pos $= "" | %db $= "")
	{
		return -1;
	}
	if($Blockscape::deletingAll || isObject($Blockscape::brickFromPos[%pos]))
	{
		return;
	}
	if(%col < 0)
	{
		%z = getWord(VectorAdd(%pos, "0 0 30"), 2);
		%name = "Sand";
		%hp = 5;
		if(%z > 12 && getRandom(0,%z))
		{
			%name = "Wet Dirt";
			%hp = 3;
		}
		if(%z > 16 && getRandom(0,%z))
		{
			%name = "Dirt";
			%hp = 6;
		}
		if(%z > 28 && getRandom(0,1))
		{
			%name = "Cobblestone";
			%hp = 10;
		}
		if(%z > 32 && getRandom(0,3))
		{
			%name = "Light Stone";
			%hp = 12;
		}
		if(%z > 36 && getRandom(0,2))
		{
			%name = "Hard Rock";
			%hp = 14;
		}
		
		%xy = getWords(%pos, 0, 1);
		%depth = ($Blockscape::groundLevel[%xy] - getWord(%pos, 2));
		if(!%isgen)
		{
			if(!getRandom(0,45) && %depth > 6 && %depth < 3200)
			{
				%colFX = 2;
				%name = "Iron";
				%hp = 21;
			}
			else if(!getRandom(0,15) && %depth > 5 && %depth < 3200)
			{
				%colFX = 2;
				%name = "Copper";
				%hp = 17;
			}
			else if(!getRandom(0,72) && %depth > 6 && %depth < 3200)
			{
				%colFX = 2;
				%name = "Gold";
				%hp = 25;
			}
			else if(!getRandom(0,80) && %depth > 30 && %depth < 3200)
			{
				%name = "Sapphire";
				%hp = 30;
			}
			else if(!getRandom(0,81) && %depth > 33 && %depth < 3200)
			{
				%name = "Ruby";
				%hp = 32;
			}
			else if(!getRandom(0,90) && %depth > 36 && %depth < 3200)
			{
				%name = "Emerald";
				%hp = 37;
			}
			else if(!getRandom(0,120) && %depth > 50 && %depth < 3200)
			{
				%colFX = 1;
				%name = "Diamond";
				%hp = 87;
			}
			else if(!getRandom(0,200) && %depth > 60 && %depth < 3200)
			{
				%colFX = 1;
				%name = "Basalt";
				%hp = 100;
			}
			else if(!getRandom(0,230) && %depth > 65 && %depth < 3200)
			{
				%colFX = 1;
				%name = "Aegisalt";
				%hp = 140;
			}
			else if(!getRandom(0,260) && %depth > 67 && %depth < 3200)
			{
				%colFX = 1;
				%name = "Cerulum";
				%hp = 170;
			}
			else if(!getRandom(0,300) && %depth > 75 && %depth < 3200)
			{
				%colFX = 1;
				%name = "Agmantite";
				%hp = 230;
			}
			else if(!getRandom(0,(%depth > 3200 ? 180 : (%depth > 176 ? 268 : 306))) && %depth > 85)
			{
				%colFX = 5;
				%name = "Sulphurice";
				%hp = 270;
			}
			else if(!getRandom(0,(%depth > 3200 ? 200 : (%depth > 176 ? 270 : 308))) && %depth > 140)
			{
				%colFX = 5;
				%name = "Uranium";
				%hp = 310;
			}
			else if(!getRandom(0,5) && %depth > 1150 && %depth < 3200)
			{
				%colFX = 1;
				%name = "Dense Crust";
				%hp = 300;
			}
			else if(!getRandom(0,5) && %depth > 1900 && %depth < 3200)
			{
				%colFX = 1;
				%name = "Compact Crust";
				%hp = 350;
			}
			else if(!getRandom(0,5) && %depth > 3200 && %depth < 5000)
			{
				%colFX = 2;
				%name = "Mantle";
				%hp = 400;
			}
			else if(!getRandom(0,5) && %depth > 3400 && %depth < 5000)
			{
				%colFX = 2;
				%name = "Dense Mantle";
				%hp = 400;
			}
			else if(!getRandom(0,30) && %depth > 4000 && %depth < 5000)
			{
				%colFX = 2;
				%name = "Obsidian";
				%hp = 500;
			}
			else if(!getRandom(0,60) && %depth > 4300)
			{
				%colFX = 2;
				%name = "Disconfigured Obsidian";
				%hp = 600;
			}
			else if(!getRandom(0,2) && %depth > 5000 && %depth < 8000)
			{
				%colFX = 3;
				%name = "Outer Core";
				%hp = 720;
			}
			else if(!getRandom(0,20) && %depth > 5000 && %depth < 8000)
			{
				%colFX = 1;
				%name = "Corusalt";
				%hp = 730;
			}
			else if(!getRandom(0,7) && %depth > 7000)
			{
				%colFX = 3;
				%name = "Geotite";
				%hp = 2000;
			}
			else if(!getRandom(0,7) && %depth > 7500)
			{
				%colFX = 3;
				%name = "Magnetite";
				%hp = 3500;
			}
			else if(!getRandom(0,1) && %depth > 8000 && %depth < 9001)
			{
				%colFX = 3;
				%name = "Inner Core";
				%hp = 10000;
			}
			else if(!getRandom(0,1) && %depth > 9000)
			{
				%colFX = 6;
				%name = "Compressed Inner Core";
				%hp = 99999;
			}
			else if(!getRandom(0,8) && %depth > 9000)
			{
				%colFX = 3;
				%name = "Planetite";
				%hp = 200000;
			}
			else if(!getRandom(0,10) && %depth > 9000)
			{
				%colFX = 3;
				%name = "Albineum";
				%hp = 400000;
			}
			else if(!getRandom(0,21) && %depth > 9500)
			{
				%colFX = 1;
				%name = "Compressed Planetite";
				%hp = 500000;
			}
			else if(!getRandom(0,27) && %depth > 9500)
			{
				%colFX = 4;
				%name = "Electric Albineum";
				%hp = 600000;
			}
			if(%depth > 9950)
			{
				%colFX = 6;
				%name = "Unbreakable Inner Core";
				%hp = -1;
			}
		}
		%z = getWord(%pos, 2);
		if($Blockscape::groundLevel[%xy] !$= "" && %z > $Blockscape::groundLevel[%xy])
		{
			return -1;
		}
		if(%isgen)
		{
			%pos = VectorAdd(%pos, "0 0 10000");
			$Blockscape::groundLevel[%xy] = getWord(%pos, 2);
			ServerPlayPitched3D(terrainPlantSound, %pos);
		}
		$Blockscape::isBlock[%pos] = true;
		%col = $Blockscape::BlockColor[%name];
	}
	else if(%bl_id)
	{
		$Blockscape::isBlock[%pos] = true;
		%name = "Wood";
		%hp = 10;
	}
	else if(%iswood)
	{
		%name = "Wood";
		%hp = 50;
	}
	
	%brick = new fxDTSBrick()
	{
		position = %pos;
		datablock = %db;
		isPlanted = true;
		colorID = %col;
		colorFxID = %colFX;
		stackBL_ID = 888888;
		placedByID = %bl_id;
		maxDamage = %hp;
		blockType = %name;
	};
	
	%brick.setTrusted(1);
	%brick.plant();
	
	%brick.creationCallMethod = trim(%pos TAB %db TAB %col TAB %isgen TAB %bl_id TAB %iswood);
	
	%chunk = (%forcechunk ? %forcechunk : $Blockscape::Chunky.getChunk(mFloor(getWord(%pos, 0) / 32) SPC mFloor(getWord(%pos, 1) / 32)));
	if(forcechunk)
	{
		announce("\c5" @ %forcechunk);
	}
	if(isObject(%chunk))
	{
		%chunk.add(%brick);
		%brick.chunk = %chunk;
	}
	else
	{
		%brick.delete();
		error("Failure to fetch Chunky chunk");
		return -1;
	}
	
	$Blockscape::brickFromPos[%pos] = %brick;
	
	return %brick;
}

if(!isObject($Blockscape::Perlin))
{
	BS_createPerlin();
}
if(!isObject($Blockscape::Chunky))
{
	BS_createChunky();
}